//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#ifndef WSCPROCEDURE_H
#define WSCPROCEDURE_H

#include <WScom.h>
class WSCbase;

class WSCprocedure{

  private:
    void* _function;
    char* _func_name;
    char* _prc_name;
    long  _effective_trg_mask; 
    char  _trg;
    unsigned _internal_prc:1;
    unsigned _src_file:1;

  public:
    WSCprocedure(char*,long);
    virtual ~WSCprocedure();
    long setProcName(char*);
    long setProc(void*);
    long setEffectiveTriggerMask(long);
    long setTrigger(long);
    long setFunction(void(*)(WSCbase*),char*);
    void setInternal(WSCbool);
    void setUseFile(WSCbool fl);

    char* getProcName();
    char* getFunctionName();
    void* getProc();
    long  getEffectiveTriggerMask();
    long  getTrigger();
    WSCbool getInternal();
    WSCbool getUseFile();
};
void WSGFsetProcedureHandler(void* hd);
void* WSGFgetProcedureHandler();
#endif
